
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/types.h>
#include "sf_convert.h"
#include "util.h"


extern char  *CCP4, *CGI_PATH,*URL_USERS_DATA, *USERS_DATA, *EXECUTE,*PATHTMP;
extern int DATA_SET;


void get_labels(FILE *fout, char **label_ptr, char **type_ptr, int ntype,  const char *fname);

void write_data_column(FILE *fout, char *align, const char *item_name,
                   const char *fname, int k, char **items,int  nitem,char **type);
void write_mtz_data_4_html(FILE *fout, char **items, int nitem,char **type, int i);



void get_mtz_infor(char *inpfile, char *path, char *pdb_id_inp)
{
    
    FILE  *fout;
    char **label_ptr=NULL, **type_ptr=NULL, **sets_ptr=NULL;
    char   outfile[512], file_new[256];
    char label[2000], type[256], sets[256];
    int i, nlabel=0, ntype=0,nsets=0;
    
    sprintf(outfile,"%sget_mtz_infor.html", PATHTMP);
    if((fout=fopen(outfile, "w"))==NULL){
        printf("Error, no written permission for dir %s!\n", PATHTMP);
        exit(0);
    }
    get_type_label_sets(inpfile, label, type, sets);
    
    label_ptr = string_token(label," ", &nlabel);
    type_ptr = string_token(type," ", &ntype);
    sets_ptr = string_token(sets," ", &nsets);
    for(i=0;i<nsets; i++){
//        printf("what is labels = %d %9s %9s %9s\n", i, label_ptr[i],type_ptr[i],sets_ptr[i]);
    }
    

    if(nlabel != ntype || nlabel != nsets ||nlabel==0){
        printf("Error! There is a problem with data set.\n");
        return;
    }
//write HTML
    fprintf(fout, "<HTML> \n <Head>\n <TITLE> Semi-auto convertion of MTZ to mmCIF format</TITLE>\n </Head>\n");
    fprintf(fout, "<br> <CENTER> <h2> Semi-auto convertion of MTZ to mmCIF format</h2></CENTER>\n");
    fprintf(fout, " <p> \n");
    
    fprintf(fout, "<form ENCTYPE=\"multipart/form-data\" Method=\"post\" Action=\"%s/get_mtz_infor.cgi\">\n", CGI_PATH);
    
    fprintf(fout, "Please <a href = \"%s/%s/mtzdmp.log\"  TARGET=\"other\"> <b>CLICK HERE </B></A>\n",URL_USERS_DATA, path);
    fprintf(fout, " to see all the data items in the MTZ file.\n");
    
    fprintf(fout, "To learn more about the MTZ format, please visit ");
    fprintf(fout, "<a href = \"http://www.ccp4.ac.uk/dist/html/mtzformat.html \" TARGET=\"other\"> <b>CCP4 site </b></a>\n");
    
    fprintf(fout, "<p>\n");
    fprintf(fout, "First, select proper item in each entry (select 'Unassigned', if no item corresponds to the entry). Second,  click RUN to convert MTZ to mmCIF, \n");

//    
//    fprintf(fout, "<tr><td colspan=3 bgcolor=\"khaki\"><font size=4 color=\"#000000\"> <center><b>\n");
//    fprintf(fout, "Number of data set  <INPUT TYPE=TEXT NAME=\"data_set\" SIZE=2 VALUE=%d > </b></center></td></tr> \n",DATA_SET );
    for(i=0; i<DATA_SET; i++){
        write_mtz_data_4_html(fout,label_ptr , nlabel, type_ptr,i);
    }
    
    fprintf(fout, "<INPUT TYPE=SUBMIT NAME=\"submit\" VALUE=\"RUN\"> \n");
    fprintf(fout, "<INPUT TYPE=RESET VALUE= \"RESET\">\n");
    fprintf(fout, "</center><p>\n");
    fprintf(fout, "\n");


    if(strstr(inpfile, "dir_")){ // rid of path
        strcpy(file_new, strstr(inpfile, "dir_")+4);
        if(strchr(file_new, '/')){
            strcpy(file_new, strchr(file_new, '/')+1);
        }    
    }
    
    fprintf(fout, "<input type=\"hidden\"  name=\"pdb_id\" value=\"%s\"> \n", pdb_id_inp);
    fprintf(fout, "<input type=\"hidden\"  name=\"infile\" value=\"%s\"> \n", file_new);
    fprintf(fout, "<input type=\"hidden\"  name=\"user_dir\" value=\"%s\"> \n", path);
    
    fprintf(fout, "<input type=\"hidden\"  name=\"url_users_data\" value=\"%s\"> \n",URL_USERS_DATA);
    fprintf(fout, "<input type=\"hidden\"  name=\"users_data\" value=\"%s\"> \n",USERS_DATA);
    fprintf(fout, "<input type=\"hidden\"  name=\"sf_convert\" value=\"%s\"> \n",EXECUTE);
    fprintf(fout, "<input type=\"hidden\"  name=\"ccp4\" value=\"%s\"> \n",CCP4);
    fprintf(fout, "<input type=\"hidden\"  name=\"data_set\" value=\"%d\"> \n",DATA_SET);
    
    fprintf(fout, "\n");
    fprintf(fout, "</BODY> </HTML>\n");
                                                                                
    fclose(fout);
   if(nlabel>0)free_memory_2d(label_ptr,nlabel);
   if(ntype>0)free_memory_2d(type_ptr,ntype);
                                                                                                       
   if(nsets>0)free_memory_2d(sets_ptr,nsets);
                                                                                                       
 
}

void write_mtz_data_4_html(FILE *fout, char **items, int nitem, char **type, int i)
{
    char  align[40];
    
    fprintf(fout, "<center>\n <table cellpadding=8 bgcolor=\"#9999cc\">\n");
    fprintf(fout, "<font color=\"blue\"><b>Data set %d </b> </font>\n", i+1);
    
    strcpy(align,"center");
// Fp and SigmaFP     
    fprintf(fout, "<tr>\n");
    write_data_column(fout, align, "Native data amplitude (FP):", "fp", i, items, nitem,type);
    write_data_column(fout, align, "Sigma (SIGFP):", "sigfp", i, items, nitem,type); 
    fprintf(fout, " </tr>\n");

//   Mean intensity sigma(IMEAN).
        
    fprintf(fout, "<tr>\n");
    
    write_data_column(fout, align, "Mean intensity (I):", "i", i, items, nitem,type);
    write_data_column(fout, align, "Sigma (SIGI): ", "sigi", i, items, nitem,type);
    fprintf(fout, " </tr>\n");

// FreeR test    
    fprintf(fout, "<tr>\n");
    write_data_column(fout, align, "Free R flag (FREE):", "free", i, items, nitem,type);
    fprintf(fout, " </tr>\n");

// I(+) and SigmaI(+)
    fprintf(fout, "<tr>\n");
    write_data_column(fout, align, "Intensity (I(+))", "iplus", i, items, nitem,type);
    write_data_column(fout, align, "Sigma (SIGI(+))", "sigiplus", i, items, nitem,type);
    fprintf(fout, " </tr>\n");

    

// I(-) and SigmaI(-)     
    fprintf(fout, "<tr>\n");
    write_data_column(fout, align, "Intensity (I(-))", "ineg", i, items, nitem,type);
    write_data_column(fout, align, "Sigma  (SIGI(-))", "sigineg", i, items, nitem,type);
    fprintf(fout, " </tr>\n");
       
    
// F(+) and SigmaF(+)
       
    fprintf(fout, "<tr>\n");
    write_data_column(fout, align, "Amplitude (F(+))", "fplus", i, items, nitem,type);
    write_data_column(fout, align, "Sigma (SIGF(+))", "sigfplus", i, items, nitem,type);
    fprintf(fout, " </tr>\n");

    

// F(-) and SigmaF(-)     
    fprintf(fout, "<tr>\n");
    write_data_column(fout, align, "Amplitude (F(-))", "fneg", i, items, nitem,type);
    write_data_column(fout, align, "Sigma  (SIGF(-))", "sigfneg", i, items, nitem,type);
    fprintf(fout, " </tr>\n");
       

//  Calculated F (FC).Calculated Phase (PHIC)
    fprintf(fout, "<tr>\n");
    write_data_column(fout, align, "Calculated F (FC):", "fc", i, items, nitem,type);
    write_data_column(fout, align, "Calculated Phase (PHIC):", "phic", i, items, nitem,type);
    fprintf(fout, " </tr>\n");


//  ABCD H/L coefficients (HLA,HLB,HLC,HLD)
    fprintf(fout, "<tr>\n");
    write_data_column(fout, align, "H/L coefficients (HLA):", "hla", i, items, nitem,type);
    write_data_column(fout, align, "H/L coefficients (HLB):", "hlb", i, items, nitem,type);
    fprintf(fout, " </tr>\n");

    fprintf(fout, "<tr>\n");
    write_data_column(fout, align, "H/L coefficients (HLC):", "hlc", i, items, nitem,type);
    write_data_column(fout, align, "H/L coefficients (HLD):", "hld", i, items, nitem,type);
    fprintf(fout, " </tr>\n");


// DP and SigmaDP (Anomalous difference for native data)    
    fprintf(fout, "<tr>\n");
    write_data_column(fout, align, "Anomalous difference(DP)", "dp", i, items, nitem,type);
    write_data_column(fout, align, "Sigma  (SIGDP)", "sigdp", i, items, nitem,type);
    fprintf(fout, " </tr>\n");

//  figure of merit  (FOM) Averaged phase (PHIB)
    fprintf(fout, "<tr>\n");
    write_data_column(fout, align, "Figure of merit  (FOM):", "fom", i, items, nitem,type);
    write_data_column(fout, align, "Averaged phase (PHIB):", "phib", i, items, nitem,type);
    fprintf(fout, " </tr>\n");

    
    fprintf(fout, "</table>\n");
}



void write_data_column(FILE *fout, char *align, const char *item_name,
                   const char *fname, int k, char **items,int nitem,  char **type)
// write item-name and corresponding field
{
    char  file_name[80];
    int i=0;
    
    sprintf(file_name,"%s_%d",fname, k+1);
    
    fprintf(fout, "<td align=%s><b>%s &nbsp <b></td>\n",align, item_name);
    fprintf(fout, "<td><SELECT NAME=\"%s\" WIDTH=10>\n", file_name);

    get_labels(fout, items, type, nitem, fname);
    
    fprintf(fout, "<OPTION VALUE=\"\">Unassigned\n");
    for (i=3; i<nitem; i++){
        fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", items[i],items[i]);
    }
    
    fprintf(fout, "</SELECT> </td>\n");
}




// NO used
void get_labels(FILE *fout, char **label_ptr, char **type_ptr, int ntype,  const char *fname)
/* according to various to cif 
only H, K, L, FP, SIGFP, DP, SIGDP, FC, PHIC, PHIB, FOM, 
I+, SIGI+, I-, SIGI-, FPART_BULK_S, PHIPART_BULK_S and FREE 
are accepted.
*/
{
    int  i=0;
     
        
    if(ntype>3){// guess the labels
        
        for(i=3; i<ntype; i++){// FOM ......
            
            if(type_ptr[i][0] == 'I' && !strcmp(fname, "free")){
                if(strstr_case(label_ptr[i], "free") ||
                   strstr_case(label_ptr[i], "flag") ||
                   strstr_case(label_ptr[i], "test")){
                    fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
                    break;
                }
            }else if(type_ptr[i][0] == 'F'  && label_ptr[i][0]== 'F' && !strcmp(fname, "fp")){
                fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
                break;
                
            }else if(type_ptr[i][0] == 'Q' && strstr_case(label_ptr[i], "SIGF") && !strcmp(fname, "sigfp")){
                fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
                break;
              
            }else if(type_ptr[i][0] == 'J' &&  label_ptr[i][0]== 'I'  && !strcmp(fname, "i")){
                
                fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
                break;
               
            }else if(type_ptr[i][0] == 'Q' &&  strstr_case(label_ptr[i], "SIGI") && !strcmp(fname, "sigi")){
                
                fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
                break;
                
            }else if(type_ptr[i][0] == 'W' && strstr_case(label_ptr[i], "FOM") && !strcmp(fname, "fom")){
                fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
                break;
                
            }else if(type_ptr[i][0] == 'P' && strstr_case(label_ptr[i], "PHIB") && !strcmp(fname, "phib")){
                fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
                break;
                
            }else if(type_ptr[i][0] == 'F' && strstr_case(label_ptr[i], "FC") && !strcmp(fname, "fc")){
                fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
                break;
            }else if(type_ptr[i][0] == 'P' && strstr_case(label_ptr[i], "PHIC") && !strcmp(fname, "phic")){
                fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
                break;
            }else if(type_ptr[i][0] == 'A' && strstr_case(label_ptr[i], "HLA") && !strcmp(fname, "hla")){
                fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
                break;
            }else if(type_ptr[i][0] == 'A' && strstr_case(label_ptr[i], "HLB") && !strcmp(fname, "hlb")){
                fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
                break;
            }else if(type_ptr[i][0] == 'A' && strstr_case(label_ptr[i], "HLC") && !strcmp(fname, "hlc")){
                fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
                break;
            }else if(type_ptr[i][0] == 'A' && strstr_case(label_ptr[i], "HLD") && !strcmp(fname, "hld")){
                fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
                break;
             }else if(type_ptr[i][0] == 'D' && !strncmp_case(label_ptr[i], "D", 1) && !strcmp(fname, "dp")){
                fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
                break;
             }else if(type_ptr[i][0] == 'Q' && strstr_case(label_ptr[i], "SIGD") && !strcmp(fname, "sigdp")){
                fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
                break;
                
             }else if( type_ptr[i][0] == 'F' && strstr(label_ptr[i], "(+)") && label_ptr[i][0]=='F' && !strcmp(fname, "fplus")){
                fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
                break;
             }else if(type_ptr[i][0] == 'Q' && strstr(label_ptr[i], "(+)") && !strncmp_case(label_ptr[i], "SIGF",4) && !strcmp(fname, "sigfplus")){
                fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
                break;
                
             }else if(type_ptr[i][0] == 'F' && strstr(label_ptr[i], "(-)") && label_ptr[i][0]=='F' && !strcmp(fname, "fneg")){
                fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
                break;
             }else if(type_ptr[i][0] == 'Q' && strstr(label_ptr[i], "(-)") && !strncmp_case(label_ptr[i], "SIGF",4) && !strcmp(fname, "sigfneg")){
                fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
                break;

                
             }else if((type_ptr[i][0] == 'K' && strstr(label_ptr[i], "(+)") && label_ptr[i][0]=='I') && !strcmp(fname, "iplus")){
                fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
                break;
             }else if((type_ptr[i][0] == 'M' && strstr(label_ptr[i], "(+)") && !strncmp_case(label_ptr[i], "SIGI",4)) && !strcmp(fname, "sigiplus")){
                fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
                break;
                
             }else if((type_ptr[i][0] == 'K' && strstr(label_ptr[i], "(-)") && label_ptr[i][0]=='I') && !strcmp(fname, "ineg")){
                fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
                break;
             }else if((type_ptr[i][0] == 'M' && strstr(label_ptr[i], "(-)") && !strncmp_case(label_ptr[i], "SIGI",4)) && !strcmp(fname, "sigineg")){
                fprintf(fout, "<OPTION VALUE=\"%s\">%s\n", label_ptr[i],label_ptr[i] );
                break;
                                                                                                         
     	     }
        }
        
        
    }
    
    
    
}

